## com.thaiopensource.validate.auto
Class RewindableReader

    java.lang.Object
      java.io.Reader
          com.thaiopensource.validate.auto.RewindableReader

All Implemented Interfaces:
  Rewindable, Closeable, Readable

    public class RewindableReader

extends Reader
implements Rewindable

Rewindable implementation over a reader. Modified from RewindableInputStream by replacing the input stream with a reader.

Author:
  george

Field Summary

Fields inherited from class java.io.Reader
`lock`

Constructor Summary
`RewindableReader(Reader in)`

Method Summary
`boolean` `canRewind()`
`void` `close()`
`int` `read()`
`int` `read(char[] b, int off, int len)`
`void` `rewind()`
`void` `willNotRewind()`

Methods inherited from class java.io.Reader
`mark, markSupported, read, read, ready, reset, skip`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### RewindableReader

    public RewindableReader(Reader in)

Method Detail

### close

    public void close()
               throws IOException

  Specified by:
    `close` in interface `Closeable`
  Specified by:
    `close` in class `Reader`
  Throws:
    `IOException`

### rewind

    public void rewind()

  Specified by:
    `rewind` in interface `Rewindable`

### canRewind

    public boolean canRewind()

  Specified by:
    `canRewind` in interface `Rewindable`

### willNotRewind

    public void willNotRewind()

  Specified by:
    `willNotRewind` in interface `Rewindable`

### read

    public int read()
             throws IOException

  Overrides:
    `read` in class `Reader`
  Throws:
    `IOException`

### read

    public int read(char[] b,
                    int off,
                    int len)
             throws IOException

  Specified by:
    `read` in class `Reader`
  Throws:
    `IOException`